#! /bin/bash

USER="$1"
[ "$USER" ] || {
	echo "Usage: $0 username";
	echo ""
	cat <<EOF 
This script creates a normal user with the name specified who is
intended to be allowed to create secondary DNS entries.  The actual
permissions granted to the user (apart from ssh login) are (1) read
and write local files via scp and (2) a script named ndc which will
perform a name server reload.  This script does not install the
host-keys for the remote user into /home/user/.ssh/authorized_keys2.
You need to do this final part manually.
EOF
	exit;
}
DNSHOME="/home/$USER"
DNSROOT="/var/named"

groupadd secdns 1>/dev/null 2>&1
# use /usr/bin/./rbash instead of /usr/bin/rbash to make sure that
# the user does not work with FTP (well, that's the idea).
useradd -s /usr/bin/./rbash $USER -d /home/$USER -g secdns
umask 027
mkdir -p $DNSHOME
cd $DNSHOME
echo 'PATH=$HOME/bin; unalias -a' > .profile
echo 'PATH=$HOME/bin; unalias -a' > .bashrc
mkdir -p bin
umask 077
mkdir -p .ssh
touch .ssh/authorized_keys2 
umask 027
ln -sf `which scp` bin/scp
echo > bin/ndc '#! /usr/bin/suidperl -w
use English;
$ENV{PATH}="/usr/sbin:/sbin:/usr/bin/:/bin"
delete @ENV{'IFS', 'CDPATH', 'ENV', 'BASH_ENV'};
$realuid=$UID;
if ( getpwuid($UID) ne "'$USER'" ) {
	die "Sorry\n";
}
$UID=0;
`rcnamed reload`
'
# suid!
chmod 4750 bin/ndc 
chown -R root:secdns $DNSHOME

# Now make an area they can write their dns requests to
umask 022
cd $DNSROOT
mkdir -p $DNSROOT/$USER
touch $DNSROOT/$USER/named.inc.$USER
chown -R $USER $DNSROOT/$USER
grep "^include $USER\\/named\\.inc\\.$USER" /etc/named.conf || 
echo "include $USER/named.inc.$USER ; " >> /etc/named.conf

